/*****************************  HashTest.java  ********************************/

import AlgoTools.IO;

/** Testet die Hash-Tabelle mit String-Objekten. Verwendet werden: 
 *  Objekt der Klasse StringCompare als Instanz des Interface Compare 
 *  Objekt der Klasse GeHashing     als Instanz des Interface Hashing
 */

public class HashTest {

    public static void main(String[] argv) {

        int groesse = IO.readInt("Bitte Groesse der Tabelle angeben: ");
        GeHashing h = new GeHashing(new StringCompare(), groesse);
        String s;

        IO.println("Gelegenheit fuer INSERT:");
        s = IO.readString("Bitte String (RETURN beendet): ");
        while (s.length()>0) {
            if (h.insert(s)) IO.println(s + " eingefuegt");
            else IO.println(s + " konnte nicht eingefuegt werden");
            IO.print(h);
            s = IO.readString("Bitte String: ");
        }

        IO.println("Gelegenheit fuer LOOKUP:");
        s = IO.readString("Bitte String (RETURN beendet): ");
        while (s.length()>0) {
            Object o = h.lookup(s);
            if (o != null)  IO.println(o + " wurde gefunden");
            else IO.println(s + " wurde nicht gefunden");
            IO.print(h);
            s = IO.readString("Bitte String: ");
        }

        IO.println("Gelegenheit fuer DELETE:");
        s = IO.readString("Bitte String (RETURN beendet): ");
        while (s.length()>0) {
            if (h.delete(s)) IO.println(s + " wurde geloescht");
            else IO.println(s + " wurde nicht geloescht");
            IO.print(h);
            s = IO.readString("Bitte String: ");
        }
    }
}
