/*****************************  Keller.java  **********************************/

import AlgoTools.IO;           

/** Abstrakter Datentyp Keller mit den Methoden push, pop, top, empty       
 */

public class Keller {

    private class KellerEintrag {
        Object inhalt;          // Inhalt des KellerEintrags
        KellerEintrag next;     // zeigt auf naechsten KellerEintrag
    }

    private KellerEintrag top;  // zeigt auf obersten KellerEintrag

    public Keller() {                                  // legt leeren Keller an
        top = null;
    }

    public boolean empty() {                           // liefert true,
        return top == null;                            // falls Keller leer
    }

    public void push(Object x) {                       // legt Objekt x    
        KellerEintrag hilf = new KellerEintrag();      // auf den Keller
        hilf.inhalt = x;
        hilf.next   = top;
        top         = hilf;
    }

    public Object top() {                              // liefert oberstes
        if (empty()) IO.error("in top: Keller leer");  // Kellerelement
        return top.inhalt;                            
    }

    public void pop() {                                // entfernt oberstes
        if (empty()) IO.error("in pop: Keller leer");  // Kellerelement
        top = top.next;
    }
}
