/*****************************  Liste.java  ***********************************/
import AlgoTools.IO;
/** ADT Liste mit empty, endpos, reset, advance, elem, insert, delete         */
    
public class Liste {

    private class ListenEintrag {
        Object        inhalt;      // Inhalt des ListenEintrags
        ListenEintrag next;        // zeigt auf naechsten ListenEintrag
    }

    private ListenEintrag anf;     // zeigt auf nullten ListenEintrag
    private ListenEintrag pos;     // zeigt auf ListenEintrag vor dem aktuellen

    public Liste() {               // kreiert eine leere Liste
        pos = anf = new ListenEintrag();
        anf.next  = null;
    }

    public boolean empty() { return anf.next == null; } // true, wenn Liste leer

    public boolean endpos() { return pos.next == null; }// true, wenn am Ende

    public void reset() {  pos = anf; }       // rueckt an den Anfang der Liste
    
    public void advance() {                             // rueckt in Liste vor
        if (endpos()) IO.error("in advance: am Ende");
        pos = pos.next;
    }

    public Object elem() {         // liefert Inhalt des aktuellen Eintrags
        if (endpos()) IO.error("in elem: kein aktueller ListenEintrag");
        return pos.next.inhalt;
    }

    public void insert(Object x) {                 // fuegt ListenEintrag ein
        ListenEintrag hilf = new ListenEintrag();  // Das neue Listenelement
        hilf.inhalt        = x;                    // kommt vor das aktuelle
        hilf.next          = pos.next;
        pos.next           = hilf;
    }

    public void delete() {                         // entfernt aktuelles Element
        if (endpos()) IO.error("in delete: kein aktueller ListenEintrag");
        pos.next = pos.next.next;
    }
}
